/*!
 * @file BufferedReader.h
 * @brief եɤ߹ߥХåե
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef BUFFERED_READER_H
#define BUFFERED_READER_H

#include <basic.h>
#include <btron/file.h>
#include "Exception.h"

typedef struct tag_FILE FILE;

#include <bstdio.h>

//! եɤ߹ߥХåե
/*!
 * եɤ߹ߤХåե󥰤뤿Υ饹Ǥ
 */
class BufferedReader {

  W filedes; //!< եǥץ

  static const int bufsize = 1024;

  B buff[bufsize]; //!< ɤ߹ߥХåե

  int bcur; //!< ɤ߹ߥХåեɤ߹߰
  int blen; //!< ɤ߹ߥХåեΥ

  W offset; //!< եɤ߽Ф֤Υեå
  mutable W fsize;

  //! EOFɤξ֤򹹿
  /*!
   * EOFɤ򡢼ºݤ˥ƥॳȤäĴ٤ƾ֤򹹿ޤ
   * @exception FileReadException եɤ߹߻˥顼
   */
  void renewEOFState() const {
    W err = rea_rec(filedes, 0, NULL, 0, &fsize, NULL);
    if (err < 0){
      throw FileReadException(filedes, err);
    }
  }

 public:

  //! 󥹥ȥ饯
  /*!
   * եǥץХåե󥰤륪֥Ȥޤ
   * @param fd оݤȤʤեǥץ
   * @exception FileReadException եɤ߹߻˥顼
   */
  BufferedReader(W fd)
    : filedes(fd), bcur(0), blen(0), offset(0), fsize(-1)
  {
    renewEOFState();
  }

  //! EOFå
  /*!
   * եνüãɤ֤ޤ
   * @retval true եνüã
   * @retval false եνüãƤʤ
   */
  bool isEOF() const {
    return ((offset >= fsize) && (bcur >= blen));
//    return eof_state && (blen == bcur);
  }

  //! ɤ߹
  /*!
   * ե뤫ǡꤷХĹɤ߹ߤޤ
   * @param target [out] ǡγǼ
   * @param size [in] targetɤ߹ХĹ
   * @return ºݤɤ߹ǡĹ
   * @exception FileReadException եɤ߹߻˥顼
   */
  int read(B* target, int size);

  //! ɤФ
  /*!
   * եꤷХĹɤߤȤФޤ
   * @param size ɤФХĹ
   * @return ºݤɤФǡĹ
   * @exception FileReadException եɤ߹߻˥顼
   */
  int skip(int size);

  //! ߤɤ߹֤߰
  /*!
   * ߤɤ߹֤߰ޤ
   * @return ºݤɤФǡĹ
   */
  int getPos() const {
    return offset - blen + bcur;
  }

  //! ǽޤǴᤷ
  /*!
   * եɤ߼֤ǽޤǴᤷޤ
   * @exception FileReadException եɤ߹߻˥顼
   */
  void rewindToStart() {
    bcur = blen = 0;
    offset = 0;
    renewEOFState();
  }

  int getFileSize() const {
    if (fsize < 0) {
      renewEOFState();
    }
    return fsize;
  }

  friend int fseek(FILE *stream, long offset, int whence);

};

#endif // BUFFERED_READER_H
