/*!
 * @file BufferedWriter.cc
 * @brief եν񤭹ߥХåե()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-03-22
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdlib.h>
#include "BufferedWriter.h"

void BufferedWriter::write(const B* target, int size)
{
  W err;

  if (bufsize - blen >= size){
    // ХåեؤΥԡǻ­
    memcpy(&(buff[blen]), target, size);
    blen += size;
    return;
  }
    
  if (blen - bcur > 0){
    flush();
  }

  err = wri_rec(filedes, -1, const_cast<B*>(target), size, NULL, NULL, 0);
  if (err < 0){
    throw FileWriteException(filedes, err);
  }
}

void BufferedWriter::flush()
{
  W err = wri_rec(filedes, -1, &(buff[bcur]), blen - bcur, NULL, NULL, 0);
  if (err < 0){
    throw FileWriteException(filedes, err);
  }
  blen = 0;
  // bcur = 0;
}
