/*!
 * @file MainMenu.h
 * @brief ᥤ˥塼
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-10-31, first edition (for BSlide)
 * @date 2005-02-27, modified for Scribble
 *
 * Copyright (C) 2004-2005, Yashiro Takeshi
 */

#ifndef MAINMENU_H
#define MAINMENU_H

#include <map>
#include <vector>
#include <basic.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>

class VobjSelection;

//! ˥塼
typedef enum tag_MainMenuItem {
  MN_VOID,
  MN_FINISH, // λ
  MN_NEWSAVE, // ¿Ȥ¸
  MN_SAVE, // ¸
  MN_REDISP, // ɽ
  MN_VOBJ, // 
  MN_ROBJ, // ¿
  MN_DISK, // ǥ
  MN_WINDOW, // ɥ
  MN_GADGET, // ʪ
  MN_EXEC, // ¹
} MainMenuItem;

//! ᥤ˥塼
/*!
 * ᥤ˥塼
 */
class MainMenu {

private:

  typedef std::map<int, MainMenuItem> MConvMap;

  //! ˥塼ܤֹΥޥåԥ
  MConvMap mcnv;

  W mid; //!< ˥塼ID
  
  void prepareMenuItems(VID vid);

public:

  //! 󥹥ȥ饯
  MainMenu();

  //! ǥȥ饯
  ~MainMenu(){
    if (mid >= 0){
      mdel_men(mid);
    }
  }
  
  //! ˥塼IDμ
  /*!
   * ƥॳǻȤΥ˥塼IDޤ
   * @return ˥塼ID
   */
  W getMenuID() const {
    return mid;
  }
  
  //! ˥塼ֹѴ
  /*!
   * popupMenu ˤ줿˥塼ֹ MainMenuItem Ѵޤ
   * @param rid ˥塼ֹ
   * @return ˥塼
   */
  MainMenuItem getInternalID(W rid) const;

  //! ˥塼Υݥåץå׼¹
  /*!
   * ˥塼ݥåץå׼¹Ԥ˥塼ֹ֤ޤ
   * @param ev [out] ٥Ȥ¸
   * @return ˥塼ֹ
   */
  W popupMenu(WEVENT *ev, const VobjSelection *vsel);

};

#endif // MAINMENU_H
