//========================================================================
//
// XPDFDisp.cc (Ȥб)
//
// Copyright 2010 Takeshi Yashiro <yashiromann@nifty.com>
//
//========================================================================

#include <basic.h>
#include <btron/file.h>
#include <btron/dp.h>
#include "GString.h"
#include "aconf.h"
#include "SplashTypes.h"
#include "SplashBitmap.h"
#include "XPDFCore.h"
#include "XPDFDisp.h"
#include "XPDFApp.h"
#include "PDFDoc.h"
#include "Vobj.h"


XPDFDisp::XPDFDisp(W gid, const LINK& lnk, const XpdfFusen& fusen)
    : m_gid(gid), m_lnk(lnk), m_fusen(fusen)
{
}

W XPDFDisp::draw(GString* ownerPwd, GString* userPwd)
{
    RECT r;
    int err;
    PAT bgpat = {{0, 16, 16, 0x10ffffff, 0x10ffffff, FILL100}};

    // طʿɤĤ֤
    wget_inf(WI_PANELBACK, &bgpat, sizeof(PAT));
    gget_fra(m_gid, &r);
    gfil_rec(m_gid, r, &bgpat, 0, G_STORE);

    // ŪΥڡ˥
    XPDFCore* core = 
        new XPDFCore(XPDFApp::getPaperRGB(), XPDFApp::getPaperPixel(),
                     XPDFApp::getMattePixel(), XPDFApp::getReverseVideo(),
                     XPDFApp::getInstallCmap(), XPDFApp::getRGBCubeSize());
    err = core->loadFile(&m_lnk, ownerPwd, userPwd);
    if (err) {
        draw_fallback();
        return 1;
    }

    core->displayPage(m_fusen.page, m_fusen.zoomx100 / 100.0, 
                      core->getRotate(), gTrue, gFalse);

    // ե꡼ž
    SplashBitmap *bmp = 
        (core->curTile != 0) ? core->curTile->bitmap : 0;
    if (bmp != 0) {
        GID bgid = bmp->getDrawEnv();
        gcop_bmp(bgid, bmp->getRect(), m_gid, bmp->getRect(),
                 0, G_STORE | G_CVFORM | G_CVCOLOR);
    }
    else {
        draw_fallback();
        return 1;
    }

    VobjSet vobjs(core->getDoc()->getNumPages());
    vobjs.load(-m_gid, &m_lnk);
    vobjs.displayPage(m_fusen.page, m_fusen.zoomx100 / 100.0, 
                      V_DISPALL|V_NOFRAME);
    vobjs.clear();

    return 0;
}

void XPDFDisp::draw_fallback()
{
    RECT r;
    static const PAT white = {{0, 16, 16, 0x10ffffff, 0x10ffffff, FILL100}};
    static const PAT black = {{0, 16, 16, 0x10000000, 0x10000000, FILL100}};

    gget_fra(m_gid, &r);
    gfil_rec(m_gid, r, const_cast<PAT*>(&white), 0, G_STORE);
    r.c.right--;
    r.c.bottom--;
    gdra_lin(m_gid, r.p.lefttop, r.p.rightbot, 0x0001, 
             const_cast<PAT*>(&black), G_STORE);
}
